diff --git a/src/main/java/net/minecraft/core/Global.java b/src/main/java/net/minecraft/core/Global.java
index 2dd5c42b9..c229ed68f 100644
--- a/src/main/java/net/minecraft/core/Global.java
+++ b/src/main/java/net/minecraft/core/Global.java
@@ -13,6 +13,16 @@ public class Global
 	public static final boolean DISABLE_OLD_WORLDS = false;
 	public static final int TEXTURE_PACK_FORMAT = Version.TEXTURE_PACK_VERSION;
 	public static final boolean NET_DEBUG = false;
+	public static final boolean ASSERTIONS_ENABLED;
+	static {
+		// Apparently the best way to check if assertions are enabled
+
+		boolean assertions = false;
+        //noinspection AssertWithSideEffects
+        assert assertions = true;
+		ASSERTIONS_ENABLED = assertions;
+	}
+
 	public static MinecraftAccessor accessor;
 
 	// Protocol version scheme:
diff --git a/src/main/java/net/minecraft/core/MinecraftAccessor.java b/src/main/java/net/minecraft/core/MinecraftAccessor.java
index d2b5e8084..90024fd58 100644
--- a/src/main/java/net/minecraft/core/MinecraftAccessor.java
+++ b/src/main/java/net/minecraft/core/MinecraftAccessor.java
@@ -1,11 +1,13 @@
 package net.minecraft.core;
 
 import net.minecraft.core.entity.SkinVariantList;
+import net.minecraft.core.sound.SoundTypes;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 
 import java.io.File;
+import java.util.Collection;
 
 public interface MinecraftAccessor
 {
@@ -23,4 +25,7 @@ public interface MinecraftAccessor
     	return false;
     }
 
+    default Collection<String> getAvailableSoundKeys() {
+        return SoundTypes.getSoundIds().keySet();
+    }
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/achievement/Achievement.java b/src/main/java/net/minecraft/core/achievement/Achievement.java
index c91467efe..6c6afcc1f 100644
--- a/src/main/java/net/minecraft/core/achievement/Achievement.java
+++ b/src/main/java/net/minecraft/core/achievement/Achievement.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.achievement;
 
-import net.minecraft.client.gui.achievements.data.AchievementPage;
 import net.minecraft.core.achievement.stat.StatDescFormatter;
 import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.item.IItemConvertible;
@@ -13,26 +12,22 @@ public class Achievement extends Stat
     public static final Type TYPE_SPECIAL = new Type("minecraft:gui/screen/achievement/achievement_special", 0xffffff80, 0xff808040, false);
     public static final Type TYPE_SECRET = new Type("minecraft:gui/screen/achievement/achievement_secret", 0xff8080ff, 0xff404080, true);
 
-    public final int x;
-    public final int y;
     public final Achievement parent;
     private final String description;
     private StatDescFormatter statStringFormatter;
     public final int iconItemId;
     private Type type = TYPE_NORMAL;
 
-    public Achievement(NamespaceID id, String name, int x, int y, IItemConvertible icon, Achievement parent)
+    public Achievement(NamespaceID id, String name, IItemConvertible icon, Achievement parent)
     {
-        this(id, name, x, y, icon.asItem().id, parent);
+        this(id, name, icon.asItem().id, parent);
     }
 
-    public Achievement(NamespaceID id, String name, int x, int y, int iconItemId, Achievement parent)
+    public Achievement(NamespaceID id, String name, int iconItemId, Achievement parent)
     {
         super(new NamespaceID(id.namespace, "achievement/" + id.value), "achievement." + name);
         this.iconItemId = iconItemId;
         this.description = "achievement." + name;
-        this.x = x;
-        this.y = y;
 
         this.parent = parent;
     }
@@ -52,12 +47,6 @@ public class Achievement extends Stat
         Achievements.achievementList.add(this);
         return this;
     }
-    public Achievement addToPage(AchievementPage ... pages){
-        for (AchievementPage page : pages){
-            page.addAchievement(this);
-        }
-        return this;
-    }
 
     @Override
 	public boolean isAchievement()
diff --git a/src/main/java/net/minecraft/core/achievement/Achievements.java b/src/main/java/net/minecraft/core/achievement/Achievements.java
index 244e95ecc..fe01435f7 100644
--- a/src/main/java/net/minecraft/core/achievement/Achievements.java
+++ b/src/main/java/net/minecraft/core/achievement/Achievements.java
@@ -1,210 +1,158 @@
 package net.minecraft.core.achievement;
 
-import com.mojang.logging.LogUtils;
-import net.minecraft.client.gui.achievements.data.AchievementPages;
-import net.minecraft.core.Global;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.collection.NamespaceID;
-import org.slf4j.Logger;
 
 import java.util.ArrayList;
 import java.util.List;
 
 public abstract class Achievements
 {
-    private static final Logger LOGGER = LogUtils.getLogger();
     public static List<Achievement> achievementList = new ArrayList<>();
     public static Achievement OPEN_INVENTORY =
-        new Achievement(new NamespaceID("minecraft", "open_inventory"), "openInventory", 0, 0, Items.BOOK, null)
-        .setClientsideAchievement().registerAchievement()
-        .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "open_inventory"), "openInventory", Items.BOOK, null)
+        .setClientsideAchievement().registerAchievement();
     public static Achievement MINE_WOOD =
-        new Achievement(new NamespaceID("minecraft", "mine_wood"), "mineWood", 2, 1, Blocks.LOG_OAK, OPEN_INVENTORY)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "mine_wood"), "mineWood", Blocks.LOG_OAK, OPEN_INVENTORY)
+            .registerAchievement();
     public static Achievement BUILD_WORKBENCH =
-        new Achievement(new NamespaceID("minecraft", "build_workbench"), "buildWorkBench", 4, -1, Blocks.WORKBENCH, MINE_WOOD)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "build_workbench"), "buildWorkBench", Blocks.WORKBENCH, MINE_WOOD)
+            .registerAchievement();
     public static Achievement BUILD_PICKAXE =
-        new Achievement(new NamespaceID("minecraft", "build_pickaxe"), "buildPickaxe", 4, 2, Items.TOOL_PICKAXE_WOOD, BUILD_WORKBENCH)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "build_pickaxe"), "buildPickaxe", Items.TOOL_PICKAXE_WOOD, BUILD_WORKBENCH)
+            .registerAchievement();
     public static Achievement BUILD_FURNACE =
-        new Achievement(new NamespaceID("minecraft", "build_furnace"), "buildFurnace", 3, 4, Blocks.FURNACE_STONE_ACTIVE, BUILD_PICKAXE)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "build_furnace"), "buildFurnace", Blocks.FURNACE_STONE_ACTIVE, BUILD_PICKAXE)
+            .registerAchievement();
     public static Achievement ACQUIRE_IRON =
-        new Achievement(new NamespaceID("minecraft", "acquire_iron"), "acquireIron", 1, 4, Items.INGOT_IRON, BUILD_FURNACE)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "acquire_iron"), "acquireIron", Items.INGOT_IRON, BUILD_FURNACE)
+            .registerAchievement();
     public static Achievement GET_DIAMONDS =
-        new Achievement(new NamespaceID("minecraft", "get_diamonds"), "getDiamonds", -1, 4, Items.DIAMOND, ACQUIRE_IRON)
+        new Achievement(new NamespaceID("minecraft", "get_diamonds"), "getDiamonds", Items.DIAMOND, ACQUIRE_IRON)
             .setType(Achievement.TYPE_SPECIAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+            .registerAchievement();
     public static Achievement BUILD_HOE =
-        new Achievement(new NamespaceID("minecraft", "build_hoe"), "buildHoe", 1, -3, Items.TOOL_HOE_WOOD, BUILD_WORKBENCH)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "build_hoe"), "buildHoe", Items.TOOL_HOE_WOOD, BUILD_WORKBENCH)
+            .registerAchievement();
     public static Achievement MAKE_BREAD =
-        new Achievement(new NamespaceID("minecraft", "make_bread"), "makeBread", -2, -3, Items.FOOD_BREAD, BUILD_HOE)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "make_bread"), "makeBread", Items.FOOD_BREAD, BUILD_HOE)
+            .registerAchievement();
     public static Achievement BAKE_CAKE =
-        new Achievement(new NamespaceID("minecraft", "bake_cake"), "bakeCake", -1, -5, Items.FOOD_CAKE, BUILD_HOE)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "bake_cake"), "bakeCake", Items.FOOD_CAKE, BUILD_HOE)
+            .registerAchievement();
     public static Achievement CRAFT_ICECREAM =
-        new Achievement(new NamespaceID("minecraft", "craft_icecream"), "craftIcecream", 1, -6, Items.BUCKET_ICECREAM, BUILD_HOE)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "craft_icecream"), "craftIcecream", Items.BUCKET_ICECREAM, BUILD_HOE)
+            .registerAchievement();
     public static Achievement CRAFT_PUMPKIN_PIE =
-        new Achievement(new NamespaceID("minecraft", "craft_pumpkin_pie"), "craftPumpkinPie", -1, -1, Items.FOOD_PUMPKIN_PIE, BUILD_HOE)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "craft_pumpkin_pie"), "craftPumpkinPie", Items.FOOD_PUMPKIN_PIE, BUILD_HOE)
+            .registerAchievement();
     public static Achievement BUILD_BETTER_PICKAXE =
-        new Achievement(new NamespaceID("minecraft", "build_better_pickaxe"), "buildBetterPickaxe", 6, 2, Items.TOOL_PICKAXE_STONE, BUILD_PICKAXE)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "build_better_pickaxe"), "buildBetterPickaxe", Items.TOOL_PICKAXE_STONE, BUILD_PICKAXE)
+            .registerAchievement();
     public static Achievement COOK_FISH =
-        new Achievement(new NamespaceID("minecraft", "cook_fish"), "cookFish", 2, 6, Items.FOOD_FISH_COOKED, BUILD_FURNACE)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "cook_fish"), "cookFish", Items.FOOD_FISH_COOKED, BUILD_FURNACE)
+            .registerAchievement();
     public static Achievement ON_A_RAIL =
-        new Achievement(new NamespaceID("minecraft", "on_a_rail"), "onARail", 2, 3, Blocks.RAIL, ACQUIRE_IRON)
+        new Achievement(new NamespaceID("minecraft", "on_a_rail"), "onARail", Blocks.RAIL, ACQUIRE_IRON)
             .setType(Achievement.TYPE_SPECIAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+            .registerAchievement();
     public static Achievement BUILD_SWORD =
-        new Achievement(new NamespaceID("minecraft", "build_sword"), "buildSword", 6, -1, Items.TOOL_SWORD_WOOD, BUILD_WORKBENCH)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "build_sword"), "buildSword", Items.TOOL_SWORD_WOOD, BUILD_WORKBENCH)
+            .registerAchievement();
     public static Achievement ALL_ARMOR_TYPES =
-        new Achievement(new NamespaceID("minecraft", "all_armor_types"), "allArmorTypes", 13, 1, Items.ARMOR_CHESTPLATE_STEEL, null)
+        new Achievement(new NamespaceID("minecraft", "all_armor_types"), "allArmorTypes", Items.ARMOR_CHESTPLATE_STEEL, null)
             .setType(Achievement.TYPE_SPECIAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+            .registerAchievement();
     public static Achievement KILL_ENEMY =
-        new Achievement(new NamespaceID("minecraft", "kill_enemy"), "killEnemy", 8, -1, Items.BONE, BUILD_SWORD)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "kill_enemy"), "killEnemy", Items.BONE, BUILD_SWORD)
+            .registerAchievement();
     public static Achievement KILL_COW =
-        new Achievement(new NamespaceID("minecraft", "kill_cow"), "killCow", 7, -3, Items.LEATHER, BUILD_SWORD)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "kill_cow"), "killCow", Items.LEATHER, BUILD_SWORD)
+            .registerAchievement();
     public static Achievement FLY_PIG =
-        new Achievement(new NamespaceID("minecraft", "fly_pig"), "flyPig", 8, -4, Items.SADDLE, KILL_COW)
+        new Achievement(new NamespaceID("minecraft", "fly_pig"), "flyPig", Items.SADDLE, KILL_COW)
             .setType(Achievement.TYPE_SPECIAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+            .registerAchievement();
     public static Achievement GET_SENSED =
-        new Achievement(new NamespaceID("minecraft", "get_sensed"), "getSensed", 9, -3, Blocks.MOTION_SENSOR_ACTIVE, KILL_ENEMY)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "get_sensed"), "getSensed", Blocks.MOTION_SENSOR_ACTIVE, KILL_ENEMY)
+            .registerAchievement();
     public static Achievement CRAFT_HANDCANNON =
-        new Achievement(new NamespaceID("minecraft", "craft_hand_cannon"), "craftHandCannon", 8, 2, Items.HANDCANNON_UNLOADED, BUILD_BETTER_PICKAXE)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "craft_hand_cannon"), "craftHandCannon", Items.HANDCANNON_UNLOADED, BUILD_BETTER_PICKAXE)
+            .registerAchievement();
     public static Achievement COLLECT_STONE =
-        new Achievement(new NamespaceID("minecraft", "collect_stone"), "collectStone", 5, 4, Blocks.COBBLE_LIMESTONE, BUILD_PICKAXE)
+        new Achievement(new NamespaceID("minecraft", "collect_stone"), "collectStone", Blocks.COBBLE_LIMESTONE, BUILD_PICKAXE)
             .setType(Achievement.TYPE_SPECIAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+            .registerAchievement();
     public static Achievement CRUSH_BLOCKS =
-        new Achievement(new NamespaceID("minecraft", "crush_blocks"), "crushBlocks", 7, 4, Blocks.ICE, BUILD_BETTER_PICKAXE)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "crush_blocks"), "crushBlocks", Blocks.ICE, BUILD_BETTER_PICKAXE)
+            .registerAchievement();
     public static Achievement REPAIR_ARMOR =
-        new Achievement(new NamespaceID("minecraft", "repair_armor"), "repairArmor", 9, 0, Items.CHAINLINK, KILL_ENEMY)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+        new Achievement(new NamespaceID("minecraft", "repair_armor"), "repairArmor", Items.CHAINLINK, KILL_ENEMY)
+            .registerAchievement();
     public static Achievement GET_CHAINMAIL =
-        new Achievement(new NamespaceID("minecraft", "get_chainmail"), "getChainmail", 11, 0, Items.ARMOR_HELMET_CHAINMAIL, REPAIR_ARMOR)
+        new Achievement(new NamespaceID("minecraft", "get_chainmail"), "getChainmail", Items.ARMOR_HELMET_CHAINMAIL, REPAIR_ARMOR)
             .setType(Achievement.TYPE_SPECIAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+            .registerAchievement();
     public static Achievement OPEN_GUIDEBOOK =
-        new Achievement(new NamespaceID("minecraft", "open_guidebook"), "openGuidebook", 0, 2, Blocks.BOOKSHELF_PLANKS_OAK, OPEN_INVENTORY)
+        new Achievement(new NamespaceID("minecraft", "open_guidebook"), "openGuidebook", Blocks.BOOKSHELF_PLANKS_OAK, OPEN_INVENTORY)
             .setClientsideAchievement()
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+            .registerAchievement();
     public static Achievement CAUGHT_EM_ALL =
-        new Achievement(new NamespaceID("minecraft", "caught_em_all"), "caughtEmAll", 4, -4, Items.LANTERN_FIREFLY_GREEN, BUILD_WORKBENCH)
+        new Achievement(new NamespaceID("minecraft", "caught_em_all"), "caughtEmAll", Items.LANTERN_FIREFLY_GREEN, BUILD_WORKBENCH)
             .setType(Achievement.TYPE_SPECIAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+            .registerAchievement();
     public static Achievement ALL_MUSIC_DISCS =
-        new Achievement(new NamespaceID("minecraft", "all_music_discs"), "allMusicDiscs", -3, 4, Items.RECORD_STAL, null)
+        new Achievement(new NamespaceID("minecraft", "all_music_discs"), "allMusicDiscs", Items.RECORD_STAL, null)
             .setType(Achievement.TYPE_SPECIAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+            .registerAchievement();
     public static Achievement TRIPLE_HIT =
-        new Achievement(new NamespaceID("minecraft", "triple_hit"), "tripleHit", 11, -2, Items.AMMO_ARROW_GOLD, KILL_ENEMY)
+        new Achievement(new NamespaceID("minecraft", "triple_hit"), "tripleHit", Items.AMMO_ARROW_GOLD, KILL_ENEMY)
             .setType(Achievement.TYPE_SPECIAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.overworldPage);
+            .registerAchievement();
 
 
     // Nether achievements
     public static Achievement ENTER_NETHER =
-        new Achievement(new NamespaceID("minecraft", "enter_nether"), "enterNether", 2, 0, Blocks.OBSIDIAN, null)
+        new Achievement(new NamespaceID("minecraft", "enter_nether"), "enterNether", Blocks.OBSIDIAN, null)
             .setType(Achievement.TYPE_SPECIAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.netherPage);
+            .registerAchievement();
     public static Achievement GET_NETHERCOAL =
-        new Achievement(new NamespaceID("minecraft", "get_nethercoal"), "getNethercoal", 1, 2, Items.NETHERCOAL, ENTER_NETHER)
+        new Achievement(new NamespaceID("minecraft", "get_nethercoal"), "getNethercoal", Items.NETHERCOAL, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.netherPage);
+            .registerAchievement();
     public static Achievement LIGHT_SIGN =
-        new Achievement(new NamespaceID("minecraft", "light_sign"), "lightSign", 4, 0, Items.DUST_GLOWSTONE, ENTER_NETHER)
+        new Achievement(new NamespaceID("minecraft", "light_sign"), "lightSign", Items.DUST_GLOWSTONE, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.netherPage);
+            .registerAchievement();
     public static Achievement SWIM_NETHER =
-        new Achievement(new NamespaceID("minecraft", "swim_nether"), "swimNether", 3, 2, Blocks.ICE, ENTER_NETHER)
+        new Achievement(new NamespaceID("minecraft", "swim_nether"), "swimNether", Blocks.ICE, ENTER_NETHER)
             .setType(Achievement.TYPE_SPECIAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.netherPage);
+            .registerAchievement();
     public static Achievement HIT_FIREBALL =
-        new Achievement(new NamespaceID("minecraft", "hit_fireball"), "hitFireball", 3, -2, Items.AMMO_FIREBALL, ENTER_NETHER)
+        new Achievement(new NamespaceID("minecraft", "hit_fireball"), "hitFireball", Items.AMMO_FIREBALL, ENTER_NETHER)
             .setType(Achievement.TYPE_SPECIAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.netherPage);
+            .registerAchievement();
     public static Achievement SLEEP_NETHER =
-        new Achievement(new NamespaceID("minecraft", "sleep_nether"), "sleepNether", 1, -2, Items.BED, ENTER_NETHER)
+        new Achievement(new NamespaceID("minecraft", "sleep_nether"), "sleepNether", Items.BED, ENTER_NETHER)
             .setType(Achievement.TYPE_SPECIAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.netherPage);
+            .registerAchievement();
     public static Achievement ENTER_OLDWORLD =
-        new Achievement(new NamespaceID("minecraft", "enter_oldworld"), "enterOldworld", 0, -5, Blocks.BEDROCK, ENTER_NETHER)
+        new Achievement(new NamespaceID("minecraft", "enter_oldworld"), "enterOldworld", Blocks.BEDROCK, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.netherPage);
+            .registerAchievement();
     public static Achievement ENTER_WARRENS =
-        new Achievement(new NamespaceID("minecraft", "enter_warrens"), "enterWarrens", 0, 5, Blocks.BEDROCK, ENTER_NETHER)
+        new Achievement(new NamespaceID("minecraft", "enter_warrens"), "enterWarrens", Blocks.BEDROCK, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.netherPage);
+            .registerAchievement();
     public static Achievement MOST_WANTED =
-        new Achievement(new NamespaceID("minecraft", "most_wanted"), "mostWanted", -0, -1, Items.TOOL_SWORD_GOLD, ENTER_NETHER)
+        new Achievement(new NamespaceID("minecraft", "most_wanted"), "mostWanted", Items.TOOL_SWORD_GOLD, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.netherPage);
+            .registerAchievement();
     public static Achievement FAST_TRAVEL = // TODO
-        new Achievement(new NamespaceID("minecraft", "fast_travel"), "fastTravel", -0, 1, Blocks.GRASS, ENTER_NETHER)
+        new Achievement(new NamespaceID("minecraft", "fast_travel"), "fastTravel", Blocks.GRASS, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
-            .registerAchievement()
-            .addToPage(AchievementPages.netherPage);
+            .registerAchievement();
 
-
-    private static boolean hasInit = false;
-    public static void init() {
-        if (hasInit) return;
-        hasInit = true;
-        AchievementPages.init();
-        LOGGER.info("{} Achievements", achievementList.size());
-    }
+    public static void init(){};
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockAlgae.java b/src/main/java/net/minecraft/core/block/BlockAlgae.java
index 6b2d71208..75924dfd1 100644
--- a/src/main/java/net/minecraft/core/block/BlockAlgae.java
+++ b/src/main/java/net/minecraft/core/block/BlockAlgae.java
@@ -3,7 +3,7 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.vehicle.BoatEntity;
+import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.LevelListener;
@@ -29,7 +29,7 @@ public class BlockAlgae extends Block
     @Override
     public void onEntityCollidedWithBlock(World world, int x, int y, int z, Entity entity)
     {
-        if(entity instanceof BoatEntity) {
+        if(entity instanceof EntityBoat) {
             int data = world.getBlockMetadata(x, y, z);
             world.playBlockEvent(null, LevelListener.EVENT_BLOCK_BREAK, x, y, z, id);
             world.setBlockWithNotify(x, y, z, 0);
diff --git a/src/main/java/net/minecraft/core/block/BlockCactus.java b/src/main/java/net/minecraft/core/block/BlockCactus.java
index 2f882f821..3f3a2deb7 100644
--- a/src/main/java/net/minecraft/core/block/BlockCactus.java
+++ b/src/main/java/net/minecraft/core/block/BlockCactus.java
@@ -4,7 +4,7 @@ import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.entity.vehicle.BoatEntity;
+import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.entity.vehicle.MinecartEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IBonemealable;
@@ -145,7 +145,7 @@ public class BlockCactus extends Block implements IBonemealable
     @Override
     public void onEntityCollidedWithBlock(World world, int x, int y, int z, Entity entity)
     {
-        if(entity instanceof Mob || entity instanceof MinecartEntity || entity instanceof BoatEntity) {
+        if(entity instanceof Mob || entity instanceof MinecartEntity || entity instanceof EntityBoat) {
         	entity.hurt(null, 1, DamageType.COMBAT);
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockMotionSensor.java b/src/main/java/net/minecraft/core/block/BlockMotionSensor.java
index 3912fc138..8e46f86b9 100644
--- a/src/main/java/net/minecraft/core/block/BlockMotionSensor.java
+++ b/src/main/java/net/minecraft/core/block/BlockMotionSensor.java
@@ -3,13 +3,11 @@ package net.minecraft.core.block;
 
 import java.util.Random;
 
-import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntitySensor;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
@@ -36,39 +34,28 @@ public class BlockMotionSensor extends BlockTileEntityVeryRotatable
         {
             return;
         }
-        spawnParticles(world, x, y, z);
-    }
-
-	private void spawnParticles(World world, int x, int y, int z) {
-		Random random = world.rand;
+        Random random = world.rand;
 
         final int redstoneBrightness = 10;
-		Color color = Colors.allRedstoneColors[redstoneBrightness];
-		if(color == null) {
-			return;
-		}
-		float red = color.getRed() / 255.0f;
-		float green = color.getGreen() / 255.0f;
-		float blue = color.getBlue() / 255.0f;
-		
-		double d = 0.0625;
-		for (int i = 0; i < 3; i++) {
-			double px = (double) x + random.nextFloat();
-			double py = (double) y + random.nextFloat();
-			double pz = (double) z + random.nextFloat();
-			
-			if (i == 0 && !world.isBlockOpaqueCube(x, y + 1, z)) py = (y + 1) + d;
-			if (i == 1 && !world.isBlockOpaqueCube(x, y - 1, z)) py = (y + 0) - d;
-			if (i == 2 && !world.isBlockOpaqueCube(x, y, z + 1)) pz = (z + 1) + d;
-			if (i == 3 && !world.isBlockOpaqueCube(x, y, z - 1)) pz = (z + 0) - d;
-			if (i == 4 && !world.isBlockOpaqueCube(x + 1, y, z)) px = (x + 1) + d;
-			if (i == 5 && !world.isBlockOpaqueCube(x - 1, y, z)) px = (x + 0) - d;
-			
-			if (px < x || px > (x + 1) || py < 0.0D || py > (y + 1) || pz < z || pz > (z + 1)) {
-				world.spawnParticle("reddust", px, py, pz, red, green, blue, redstoneBrightness);
-			}
-		}
-	}
+
+        double d = 0.0625;
+        for (int i = 0; i < 6; i++) {
+            double px = (double) x + random.nextFloat();
+            double py = (double) y + random.nextFloat();
+            double pz = (double) z + random.nextFloat();
+
+            if (i == 0 && !world.isBlockOpaqueCube(x, y + 1, z)) py = (y + 1) + d;
+            if (i == 1 && !world.isBlockOpaqueCube(x, y - 1, z)) py = (y + 0) - d;
+            if (i == 2 && !world.isBlockOpaqueCube(x, y, z + 1)) pz = (z + 1) + d;
+            if (i == 3 && !world.isBlockOpaqueCube(x, y, z - 1)) pz = (z + 0) - d;
+            if (i == 4 && !world.isBlockOpaqueCube(x + 1, y, z)) px = (x + 1) + d;
+            if (i == 5 && !world.isBlockOpaqueCube(x - 1, y, z)) px = (x + 0) - d;
+
+            if (px < x || px > (x + 1) || py < 0.0D || py > (y + 1) || pz < z || pz > (z + 1)) {
+                world.spawnParticle("reddust", px, py, pz, 0, 0, 0, redstoneBrightness);
+            }
+        }
+    }
 
     @Override
     public boolean isSignalSource()
diff --git a/src/main/java/net/minecraft/core/block/BlockOreRedstone.java b/src/main/java/net/minecraft/core/block/BlockOreRedstone.java
index 656673259..92ea40c37 100644
--- a/src/main/java/net/minecraft/core/block/BlockOreRedstone.java
+++ b/src/main/java/net/minecraft/core/block/BlockOreRedstone.java
@@ -6,9 +6,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 
@@ -111,18 +109,9 @@ public class BlockOreRedstone extends Block
 		Random random = world.rand;
 
         final int redstoneBrightness = 10;
-		Color color = Colors.allRedstoneColors[redstoneBrightness];
-		if(color == null) {
-			return;
-		}
-		
-		float red = color.getRed() / 255.0f;
-		float green = color.getGreen() / 255.0f;
-		float blue = color.getBlue() / 255.0f;
-		
 		
 		double d = 0.0625;
-		for (int i = 0; i < 3; i++) {
+		for (int i = 0; i < 6; i++) {
 			double px = (double) x + random.nextFloat();
 			double py = (double) y + random.nextFloat();
 			double pz = (double) z + random.nextFloat();
@@ -135,7 +124,7 @@ public class BlockOreRedstone extends Block
 			if (i == 5 && !world.isBlockOpaqueCube(x - 1, y, z)) px = (x) - d;
 			
 			if (px < x || px > (x + 1) || py < 0.0D || py > (y + 1) || pz < z || pz > (z + 1)) {
-				world.spawnParticle("reddust", px, py, pz, red, green, blue, redstoneBrightness);
+				world.spawnParticle("reddust", px, py, pz, 0, 0, 0, redstoneBrightness);
 			}
 		}
     }
